import request from '~/utils/request';
import type { ApiResult } from '@/api';
import type { User } from '@/api/system/user/model';
import type { UpdatePasswordParam } from './model';
import type {CmsWebsite, CmsWebsiteParam} from "~/api/cms/cmsWebsite/model";
import {COMMON_API_URL, SERVER_API_URL} from "~/config";

/**
 * 获取网站信息
 */
export async function getSiteInfo(params: CmsWebsiteParam) {
  const res = await request.get<ApiResult<CmsWebsite>>(
    '/cms/cms-website/getSiteInfo',
      {
        params
      }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取当前登录的用户信息、菜单、权限、角色
 */
export async function getUserInfo(): Promise<User> {
  const config = useRuntimeConfig();
  const res = await request.get<ApiResult<User>>(COMMON_API_URL + '/auth/user',{
    headers: {
      TenantId: `${localStorage.getItem('ServerTenantId')}`
    }
  });
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function updateUser(data: User){
  const res = await request.put<ApiResult<unknown>>(
      SERVER_API_URL + '/auth/user',
      data
  );
  if (res.code === 0) {
    return res.message ?? '修改成功';
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取服务器时间(实时)
 * @return
 */
export async function getServerTime() {
  const res = await request.get<ApiResult<any>>(
    '/cms/website/getServerTime'
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取未来7天的日期
 * @return
 */
export async function getNext7day() {
  const res = await request.get<ApiResult<any>>(
    '/cms/website/getNext7day'
  );
  console.log('res.data.code: ', res.data.code);
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 向子模块传递token
 * @param url
 */
export async function transferToken(url: string): Promise<string> {
  const res = await request.get<ApiResult<unknown>>(url);
  return Promise.reject(new Error(res.message));
}

/**
 * 修改当前登录的用户密码
 */
export async function updatePassword(
  data: UpdatePasswordParam
): Promise<string> {
  const res = await request.put<ApiResult<unknown>>(
    '/auth/password',
    data
  );
  if (res.code === 0) {
    return res.message ?? '修改成功';
  }
  return Promise.reject(new Error(res.message));
}
